export interface IRenderPageParams {
    pageName: string;
    pageDir: string;
    pageStoreFile: string;
}
export default class Generator {
    private srcPath;
    private tempPath;
    private applyMethod;
    private disableResetPageState;
    constructor({ srcPath, tempPath, applyMethod, disableResetPageState, }: {
        srcPath: string;
        tempPath: string;
        applyMethod: Function;
        disableResetPageState: boolean;
    });
    render(rerender?: boolean): void;
    private renderAppStore;
    private renderAppStoreTypes;
    private renderPageComponent;
    private kebabToPascal;
    private renderPageLayout;
}
