"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var globby = require("globby");
var chalk = require("chalk");
var getPath_1 = require("./getPath");
/**
 * Check if the src/pages/${pageName}/index.[j|t]s?(x) or src/pages/${pageName}/Layout/index.[j|t]s?(x) exists
 * @param pagePath the page dir absolute path. e.g. /basic-store/src/page/About
 */
exports.default = (function (pagePath) {
    var pageStorePath = (0, getPath_1.getPageStorePath)(pagePath);
    if (pageStorePath) {
        var matchingPaths = globby.sync(['index.@((t|j)s?(x))', 'Layout/index.@((t|j)s?(x))'], { cwd: pagePath });
        if (!matchingPaths.length) {
            console.log(chalk.yellow(chalk.black.bgYellow(' WARNING '), "The page ".concat(pagePath, " has no index.[js|jsx|tsx] or Layout/index.[js|jsx|tsx]. Please wrap the <Provider> in this page by yourself. For more detail, please see https://ice.work/docs/guide/basic/store.")));
        }
    }
});
//# sourceMappingURL=checkPageIndexFileExists.js.map