"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var getPath_1 = require("./getPath");
function checkStoreExists(srcPath, pagesName) {
    var appStoreExists = checkAppStoreExists(srcPath);
    var pageStoreExists = checkPageStoreExists(srcPath, pagesName);
    return appStoreExists || pageStoreExists;
}
function checkAppStoreExists(srcPath) {
    var appStorePath = (0, getPath_1.getAppStorePath)(srcPath);
    return !!appStorePath;
}
function checkPageStoreExists(srcPath, pagesName) {
    return pagesName.some(function (pageName) {
        var pageDir = (0, getPath_1.getPageDir)(srcPath, pageName);
        var pageStorePath = (0, getPath_1.getPageStorePath)(pageDir);
        return !!pageStorePath;
    });
}
exports.default = checkStoreExists;
//# sourceMappingURL=checkStoreExists.js.map