"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRouteFileType = exports.getStoreFileType = void 0;
var path = require("path");
var fse = require("fs-extra");
var fileTypes = ['.js', '.ts'];
var jsxFileTypes = ['.jsx', '.tsx'];
/**
 * return the store file type: '.js' | '.ts' | ''
 */
function getStoreFileType(dirPath) {
    return fileTypes.find(function (fileType) { return fse.pathExistsSync(path.join(dirPath, "store".concat(fileType))); }) || '';
}
exports.getStoreFileType = getStoreFileType;
/**
 * return the route file type: '.js' | '.ts' | ''
 */
function getRouteFileType(dirPath) {
    return __spreadArray(__spreadArray([], fileTypes, true), jsxFileTypes, true).find(function (fileType) { return fse.pathExistsSync(path.join(dirPath, "routes".concat(fileType))); }) || '';
}
exports.getRouteFileType = getRouteFileType;
//# sourceMappingURL=getFileType.js.map