"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPageStorePath = exports.getPageDir = exports.getAppStorePath = void 0;
var path = require("path");
var fse = require("fs-extra");
var getFileType_1 = require("./getFileType");
function getAppStorePath(srcPath) {
    var storeFileType = (0, getFileType_1.getStoreFileType)(srcPath);
    // e.g: src/store.ts
    return storeFileType ? path.join(srcPath, "store".concat(storeFileType)) : '';
}
exports.getAppStorePath = getAppStorePath;
/**
 * return absolute page dir path. e.g.: /project/src/pages/Home
 */
function getPageDir(srcPath, pageName) {
    var pagesDir = path.join(srcPath, 'pages');
    var pagePath = path.join(pagesDir, pageName);
    // if page path is /src/pages/index.tsx, return /src/pages
    return fse.pathExistsSync(pagePath) ? pagePath : pagesDir;
}
exports.getPageDir = getPageDir;
function getPageStorePath(pagePath) {
    var storeFileType = (0, getFileType_1.getStoreFileType)(pagePath);
    // e.g: src/pages/Home/store.ts
    return storeFileType ? path.join(pagePath, "store".concat(storeFileType)) : '';
}
exports.getPageStorePath = getPageStorePath;
//# sourceMappingURL=getPath.js.map