"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var app_helpers_1 = require("@builder/app-helpers");
var getPageName = function (resolveId) {
    var layoutRegExp = /src\/pages\/([^/*"]+)*\/Layout/;
    var pageRegExp = /src\/pages\/([^/*"]+)*((.tsx|.jsx?)$|(\/index(.tsx|.jsx?)?)?$)/;
    var type = '';
    if (resolveId.match(pageRegExp)) {
        type = 'page';
    }
    else if (resolveId.match(layoutRegExp)) {
        type = 'layout';
    }
    var _a = resolveId.match(pageRegExp) || resolveId.match(layoutRegExp) || [], pageName = _a[1];
    return { type: type, pageName: pageName };
};
var vitePluginPageRedirect = function (rootDir, routesPaths) {
    var formattedRoutes = routesPaths.map(app_helpers_1.formatPath);
    return {
        enforce: 'pre',
        name: 'vite-plugin-page-redirect',
        resolveId: function (id, importer) {
            if (formattedRoutes.includes((0, app_helpers_1.formatPath)(importer))) {
                var importPath = id;
                // relative path
                if (/^(\.\/|\.{2}\/)/.test(importPath)) {
                    importPath = (0, app_helpers_1.formatPath)(path.join(path.dirname(importer), importPath));
                }
                // if import path includes alias, it will be resolved as absolute path
                var _a = getPageName(importPath), type = _a.type, pageName = _a.pageName;
                if (pageName && type)
                    return path.join(rootDir, "/.ice/pages/".concat(pageName).concat(type === 'layout' ? '/Layout' : '', "/index.tsx"));
            }
        },
    };
};
exports.default = vitePluginPageRedirect;
//# sourceMappingURL=vitePluginPageRedirect.js.map